const _ = require("lodash");
const ko = require("knockout");

const Dialog = require("cattura-ui-library/src/lib/ui/dialog");

let streamConfigurationId = ko.observable();
let form = ko.observable();

function makeDialog (plugin, rtmpPlugin)
{
    return Dialog({
        id: streamConfigurationId,

        form: form,

        open (streamConfiguration)
        {
            this.reset();
            this.form(rtmpPlugin().encodingForm({
                showInputField:      false,
                showResolutionField: true,
                showFpsField:        true
            }));
            
            if (streamConfiguration && streamConfiguration.id)
            {
                this.id(streamConfiguration.id);
                this.form().config(streamConfiguration.configuration);
            }

            this.show();
        },

        reset ()
        {
            this.id(null);
            
            if (this.form())
            {
                this.form().reset();
            }
        },

        save ()
        {
            let config = _(this.form().config())
                .omit(["ingestSource", "username", "password", "host", "appName", "streamNameOrKey"])
                .value();
            
            (this.id() ? plugin.updateStreamConfiguration(this.id(), config) : plugin.addStreamConfiguration(config))
                .then(() => this.hide());
        }
    }, {
        template: require("./content.pug")
    });
}

module.exports = makeDialog;
